<template>
    <!-- ############# MODAL ############# -->
    <div>

        <div class="modal animated bounceInUp  large-modal" id="imageModal-1" tabindex="-1" role="dialog" aria-labelledby="myLargeModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">×</span>
                        </button>
                        <h4 class="modal-title" id="mySmallModalLabel">Galería de imágenes</h4>
                    </div>
                    <div class="modal-body modal-contenedor">
                        
                        <form class="form-material" id="form-image-1">

                            <div class="form-group row">

                                <div class="col-md-12" id="leftside">
                                    <div class="col-md-12 bg-tittle-content">
                                        <h2>Imagen</h2>
                                        <small>Imagen (415x415px) </small>
                                    </div>
                                    <input type="file" id="ref-small-image" 
                                        :data-max-width="maxDimenssionsSmall.width" 
                                        :data-max-height="maxDimenssionsSmall.height" 
                                        :data-allowed-file-extensions="allowedFileExtensionsSmall"
                                         data-max-file-size-preview="10M" 
                                        class="dropify" />
                                    <div class="sk-three-bounce load-content2"  v-show="uploading">
                                        <div class="sk-child sk-bounce1 bg-info"></div>
                                        <div class="sk-child sk-bounce2 bg-info"></div>
                                        <div class="sk-child sk-bounce3 bg-info"></div>
                                    </div>

                                    <div class="switch">
                                        <input type="radio" class="switch-input" v-model="imgTypeSmall" name="imgtypeSmall" value="reference" id="reference" checked>
                                        <label for="reference" class="switch-label switch-label-off">Refere</label>

                                        <input type="radio" class="switch-input" v-model="imgTypeSmall" name="imgtypeSmall" value="final" id="final">
                                        <label for="final" class="switch-label switch-label-on">Final</label>
                                        
                                        <span class="switch-selection"></span>
                                    </div>
                                    
                                    <span class="tag tag-pill tag-warning">No cierre la ventana hasta guardar la imagen</span>
                                </div>

                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cerrar</button>
                        <button type="button" class="btn btn-info" @click.prevent="uploadSmallFile">Grabar</button>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal animated bounceInUp  large-modal2" tabindex="-1" role="dialog" id="imageModal-2"  aria-labelledby="myLargeModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">×</span>
                        </button>
                        <h4 class="modal-title" id="mySmallModalLabel">Galería de imágenes</h4>
                    </div>
                    <div class="modal-body modal-contenedor">
                        <form class="form-material ">
                                                        <div class="form-group row">

                                <div class="col-md-12" id="leftside">
                                    <div class="col-md-12 bg-tittle-content">
                                        <h2>Imagen</h2>
                                        <small>Imagen de ayuda (895x313px) </small>
                                    </div>
                                    <input type="file" id="ref-large-image" 
                                        :data-max-width="maxDimenssionsLarge.width" 
                                        :data-max-height="maxDimenssionsLarge.height" 
                                        :data-allowed-file-extensions="allowedFileExtensionsLarge"
                                         data-max-file-size-preview="10M" 
                                        class="dropify" />
                                    <div class="sk-three-bounce load-content2"  v-show="uploading">
                                        <div class="sk-child sk-bounce1 bg-info"></div>
                                        <div class="sk-child sk-bounce2 bg-info"></div>
                                        <div class="sk-child sk-bounce3 bg-info"></div>
                                    </div>

                                    <div class="switch">
                                        <input type="radio" class="switch-input" v-model="imgTypeLarge" name="imgTypeLarge" value="reference" id="reference2" checked>
                                        <label for="reference2" class="switch-label switch-label-off">Refere</label>

                                        <input type="radio" class="switch-input" v-model="imgTypeLarge" name="imgTypeLarge" value="final" id="final2">
                                        <label for="final2" class="switch-label switch-label-on">Final</label>
                                        
                                        <span class="switch-selection"></span>
                                    </div>
                                    <span class="tag tag-pill tag-warning">No cierre la ventana hasta guardar la imagen</span>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cerrar</button>
                        <button type="button" class="btn btn-info" @click.prevent="uploadLargeFile">Grabar</button>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal animated bounceInUp  default-modal" id="audioModal" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-sm">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">×</span>
                        </button>
                        <h4 class="modal-title" id="mySmallModalLabel">Galería de audio</h4>
                    </div>
                    <div class="modal-body modal-contenedor">
                        <form class="form-material" enctype="multipart/form-data">
                            <div class="form-group row">

                                <div class="col-md-12 ">
                                    <div class="col-md-12 bg-tittle-content">
                                        <h2>Audio final</h2>
                                        <small>Audio</small>
                                    </div>
                                    
                                    <input type="file" id="ref-audio" class="dropify" />
                                    <div class="sk-three-bounce load-content2"  v-show="uploading">
                                        <div class="sk-child sk-bounce1 bg-info"></div>
                                        <div class="sk-child sk-bounce2 bg-info"></div>
                                        <div class="sk-child sk-bounce3 bg-info"></div>
                                    </div>
                                </div>

                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cerrar</button>
                        <button type="button" class="btn btn-info" @click.prevent="uploadAudio">Grabar</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>

import { mapGetters, mapActions } from 'vuex'
import api from '../../../../api'
export default {
    data(){
        return {
            uploading : false,
            imgTypeSmall : "reference",
            imgTypeLarge : "reference",
        }
    },
    computed: {
            maxDimenssionsSmall(){
                return { 
                        height: this.imgTypeSmall == "final" ? 416 : 1000, 
                        width : this.imgTypeSmall == "final" ? 416 : 1000   
                    }
            },
            maxDimenssionsLarge(){
                return { 
                        height: this.imgTypeLarge == "final" ? 896 : 1000, 
                        width : this.imgTypeLarge == "final" ? 1000 : 1000   
                    }
            },
            allowedFileExtensionsSmall(){
                return this.imgTypeSmall == "final" ? "jpg" : "jpg jpeg png"
            },
            allowedFileExtensionsLarge(){
                return this.imgTypeLarge == "final" ? "jpg" : "jpg jpeg png"
            },
        ...mapGetters([
            'currentSessionBuilderWeek',
            'courseBuilderInfo',
        ]),
    },
    props: {
        info: {
            type: Object,
            required: true
        }
    },
    methods: {
        uploadSmallFile() {
            this.uploading   = true
            let formData     = new FormData();
            let imagefile    = document.querySelector('#ref-small-image');
                formData.append("image_path", imagefile.files[0]);
                formData.append("name", this.info.name);
                formData.append("course", this.courseBuilderInfo.name);
                formData.append("course_id", this.courseBuilderInfo.id);
                formData.append("week", this.currentSessionBuilderWeek);
                api.uploadFile(formData).then(response => {
                    this.uploading = false
                    if(this.info.multiple){
                        this.$emit('multiFileuploaded', { path: response, imgtype: this.imgTypeSmall, index: this.info.trigger, multiple_index : this.info.multiple_index })
                    }
                    else{
                        this.$emit('fileuploaded', { path: response, imgtype: this.imgTypeSmall, index: this.info.trigger })
                    }
                    
                    $('.dropify-clear').click();
                    imagefile.value = ''
                    this.imgTypeSmall = 'default'
                    $('#imageModal-1').modal('toggle')
                })
        },
        uploadLargeFile() {
            this.uploading   = true
            let formData     = new FormData();
            let imagefile    = document.querySelector('#ref-large-image');
            
                formData.append("image_path", imagefile.files[0]);
                formData.append("name", this.info.name);
                formData.append("course", this.courseBuilderInfo.name);
                formData.append("course_id", this.courseBuilderInfo.id);
                formData.append("week", this.currentSessionBuilderWeek);
                api.uploadFile(formData).then(response => {
                    this.uploading = false
                    
                    if(this.info.multiple){
                        this.$emit('multiFileuploaded', { path: response, imgtype: this.imgTypeLarge, index: this.info.trigger, multiple_index : this.info.multiple_index })
                    }
                    else{
                        this.$emit('fileuploaded', { path: response, imgtype: this.imgTypeLarge, index: this.info.trigger })
                    }
                    $('.dropify-clear').click();
                    imagefile.value = ''
                    this.imgTypeLarge = 'reference'
                    $('#imageModal-2').modal('toggle')
                })
        },
        uploadAudio() {
            this.uploading   = true
            let formData     = new FormData();
            let audiofile    = document.querySelector('#ref-audio');
                formData.append("audio", audiofile.files[0]);
                formData.append("name", this.info.name);
                formData.append("course", this.courseBuilderInfo.name);
                formData.append("course_id", this.courseBuilderInfo.id);
                formData.append("week", this.currentSessionBuilderWeek);
                api.uploadAudio(formData).then(response => {
                    this.uploading = false
                    this.$emit('audiouploaded', { path: response, index: this.info.trigger, multiple_index: this.info.multiple_index })
                    $('.dropify-clear').click();
                    $('#audioModal').modal('toggle')
                })
        },
    },
    watch : {
     info: {
      handler(val) {
        let dropify = $('#imageModal-1 .dropify').dropify().data('dropify')
        if(dropify){
            dropify.destroy();
            if(val.current_image){
                dropify.settings.defaultFile  = val.current_image.split('?')[0]
            }
            dropify.init()
        }
      },
      deep: true
    },
        imgTypeSmall(val){
            if(val == "final"){
                let dropify = $('#imageModal-1 .dropify').dropify().data('dropify')
                if(dropify){
                    dropify.destroy();
                    dropify.settings.maxHeight = this.maxDimenssionsSmall.height
                    dropify.settings.maxWidth  = this.maxDimenssionsSmall.width
                    dropify.settings.allowedFileExtensions  = this.allowedFileExtensionsSmall.split(' ')
                    dropify.init()
                }
            }
            else if(val == "reference"){
                let dropify = $('#imageModal-1 .dropify').dropify().data('dropify')
                if(dropify){
                    dropify.destroy();
                    dropify.settings.maxHeight = this.maxDimenssionsSmall.height
                    dropify.settings.maxWidth  = this.maxDimenssionsSmall.width
                    dropify.settings.allowedFileExtensions  = this.allowedFileExtensionsSmall.split(' ')
                    dropify.init()
                }
            }
        },
        imgTypeLarge(val){
            if(val == "final"){
                let dropify = $('#imageModal-2 .dropify').dropify().data('dropify')
                if(dropify){
                    dropify.destroy();
                    dropify.settings.maxHeight = this.maxDimenssionsLarge.height
                    dropify.settings.maxWidth  = this.maxDimenssionsLarge.width
                    dropify.settings.allowedFileExtensions  = this.allowedFileExtensionsLarge.split(' ')
                    dropify.init()
                }
            }
            else if(val == "reference"){
                let dropify = $('#imageModal-2 .dropify').dropify().data('dropify')
                if(dropify){
                    dropify.destroy();
                    dropify.settings.maxHeight = this.maxDimenssionsLarge.height
                    dropify.settings.maxWidth  = this.maxDimenssionsLarge.width
                    dropify.settings.allowedFileExtensions  = this.allowedFileExtensionsLarge.split(' ')
                    dropify.init()
                }
            }
        }
    },
    mounted() {
        $('#imageModal-1 .dropify').dropify({
            messages: {
                default: 'Escoge tu imagen',
                replace: 'Click para reemplazar la imagen',
                remove: 'Eliminar',
                error: 'No pudimos subir la imágen'
            },
            error: {
                'fileSize': 'El tamaño el archivo es muy alto ({{ value }} max).',
                'minWidth': 'El ancho de la imagen es muy pequeño ({{ value }}px min).',
                'maxWidth': 'El ancho de la imagen es muy grande ({{ value }}px max).',
                'minHeight': 'El alto de la imagen es muy pequeño ({{ value }}px min).',
                'maxHeight': 'El ancho de la imagen es muy grande ({{ value }}px max).',
                'allowedFileExtensions': 'El formato de la imagen no es permitido ({{ value }} ).',
                'imageFormat': 'El formato de la imagen no es permitido ({{ value }} ).'
            } 
        });

        $('#imageModal-2 .dropify').dropify({
            messages: {
                default: 'Escoge tu imagen',
                replace: 'Click para reemplazar la imagen',
                remove: 'Eliminar',
                error: 'No pudimos subir la imágen'
            },
            error: {
                'fileSize': 'El tamaño el archivo es muy alto ({{ value }} max).',
                'minWidth': 'El ancho de la imagen es muy pequeño ({{ value }}px min).',
                'maxWidth': 'El ancho de la imagen es muy grande ({{ value }}px max).',
                'minHeight': 'El alto de la imagen es muy pequeño ({{ value }}px min).',
                'maxHeight': 'El ancho de la imagen es muy grande ({{ value }}px max).',
                'imageFormat': 'El formato de la imagen no es permitido, ({{ value }}).',
                'allowedFileExtensions': 'El formato de la imagen no es permitido, ({{ value }}).',
            }
        });

        $('#audioModal .dropify').dropify({
            messages: {
                default: 'Escoge tu audio (mp3)',
                replace: 'Click para reemplazar el audio',
                remove: 'Eliminar',
                error: 'No pudimos subir el archivo de audio'
            }
        });
    }
}
</script>
<style>
.switch {
  position: relative;
  margin: 20px auto;
  height: 26px;
  width: 120px;
  background: #ddd;
}

.switch-label {
  position: relative;
  z-index: 2;
  float: left;
  width: 58px;
  line-height: 26px;
  font-size: 13px;
  text-transform: uppercase;
  color: rgba(0, 0, 0, 0.45);
  text-align: center;
  cursor: pointer;
}

.switch-label:active {
  font-weight: bold;
}

.switch-label-off {
  padding-left: 2px;
}

.switch-label-on {
  padding-right: 2px;
}

.switch-input {
  display: none;
}

.switch-input:checked + .switch-label {
  font-weight: bold;
  color: rgba(0, 0, 0, 0.65);
  -webkit-transition: 0.15s ease-out;
  -moz-transition: 0.15s ease-out;
  -o-transition: 0.15s ease-out;
  transition: 0.15s ease-out;
}

.switch-input:checked + .switch-label-on ~ .switch-selection {
  /* Note: left: 50% doesn't transition in WebKit */
  left: 60px;
}

.switch-selection {
  display: block;
  position: absolute;
  z-index: 1;
  width: 60px;
  height: 26px;
  background: #20b9ae;
  -webkit-transition: left 0.15s ease-out;
  -moz-transition: left 0.15s ease-out;
  -o-transition: left 0.15s ease-out;
  transition: left 0.15s ease-out;
}

.switch-blue .switch-selection {
  background: #3aa2d0;
  background-image: -webkit-linear-gradient(top, #4fc9ee, #3aa2d0);
  background-image: -moz-linear-gradient(top, #4fc9ee, #3aa2d0);
  background-image: -o-linear-gradient(top, #4fc9ee, #3aa2d0);
  background-image: linear-gradient(to bottom, #4fc9ee, #3aa2d0);
}

.switch-yellow .switch-selection {
  background: #c4bb61;
  background-image: -webkit-linear-gradient(top, #e0dd94, #c4bb61);
  background-image: -moz-linear-gradient(top, #e0dd94, #c4bb61);
  background-image: -o-linear-gradient(top, #e0dd94, #c4bb61);
  background-image: linear-gradient(to bottom, #e0dd94, #c4bb61);
}
</style>
